	.dbfile C:\iccv7arm\MICROM~1\MI35D7~1\MicroBoltMath.c
	AREA	"C$$code", CODE, READONLY
	EXPORT _main
	.dbfunc e main _main fV
	AREA	"C$$code", CODE, READONLY
	ALIGN 4
;       FloatNum -> R6
;          Delay -> R7
_main:
	.dbline -1
	.dbline 40
; /*
; |------------------------------------------------------------------------------------------
; |------------------------------------------------------------------------------------------
; | File Name			  : MicroBoltMath.c																					
; | Author			    : Micromint, Inc.						
; | Copyright       : Copyright  2005, Micromint, Inc.																	
; | Creation Date		: 4/2/05																							
; | Version			    : 1.00																																												
; | Spaces per tab	:	2																									
; | Description		  : Main C file																																									 
; | Revision			  :	Initial																																																						
; |------------------------------------------------------------------------------------------
; |------------------------------------------------------------------------------------------
; */
; 
; /*
; |----------------------------------------------------
; |     Includes
; |----------------------------------------------------
; */
; 
; #include <ARM/philips/lpc210x.h>
; 
; #include <arm_macros.h>
; 
; #include "MicroBoltMath.h"
; 
; /*
; |------------------------------------------------------------------------------------------
; |     Function        :   main
; |     Inputs          :   None
; |     Outputs         :   None
; |     Purpose         :   Main function for system
; |     Author          :   Micromint, Inc.
; |------------------------------------------------------------------------------------------
; */
; 
; 
; void main(void)
;   {
	.dbline 50
; 	unsigned int Delay;
;   float FloatNum;
; 
; /*
; |----------------------------------------------------
; |     MicroBolt hardware setup 
; |----------------------------------------------------
; */
; 
;   __DISABLE_INTERRUPT();                        // Disable all interrupts
	mrs R12,cpsr
	orr R12,R12,#0x80
	msr cpsr_c,R12
	
	.dbline 52
; 
;   MAM_CR = 0x00;                                // Turn MAM off (default)
	mov R4,#0
	ldr R5,LIT_main+0
	str R4,[R5,#0]
	.dbline 53
;   MAM_TIM = 0x04;                               // Set flash timing to 4 clock cycles
	mov R4,#4
	ldr R5,LIT_main+4
	str R4,[R5,#0]
	.dbline 55
; 
;   MAM_CR = 0x02;                                // Fully enable the Memory Accleration Module
	mov R4,#2
	ldr R5,LIT_main+0
	str R4,[R5,#0]
	.dbline 57
; 
;   VICVectAddr8 = (unsigned)pll_isr;             // Assign the PLL lock ISR vector address
	ldr R4,LIT_main+8
	ldr R5,LIT_main+12
	str R4,[R5,#0]
	.dbline 58
;   VICVectCntl8 = INTERRUPT_CHANNEL_FOR_PLL;     // Assign the VIC address to the actual interrupt
	mov R4,#44
	ldr R5,LIT_main+16
	str R4,[R5,#0]
	.dbline 59
;   VICIntEnable = INTERRUPT_ENABLE_FOR_PLL;      // Enable the interrupt  
	mov R4,#4096
	ldr R5,LIT_main+20
	str R4,[R5,#0]
	.dbline 61
; 
;   SCB_PLLCFG |= 0x23;				 	   		            // Set to 59 MHz (0x03 is multiply value of 4)
	ldr R4,LIT_main+24
	ldr R5,[R4,#0]
	orr R5,R5,#35
	str R5,[R4,#0]
	.dbline 62
;   SCB_PLLCON |= 0x01;                           // Enable the PLL 
	ldr R4,LIT_main+28
	ldr R5,[R4,#0]
	orr R5,R5,#1
	str R5,[R4,#0]
	.dbline 63
;   SCB_PLLFEED = 0xAA;					   	  	          // Shadow register copy to enable changes
	mov R4,#170
	ldr R5,LIT_main+32
	str R4,[R5,#0]
	.dbline 64
;   SCB_PLLFEED = 0x55;                           // in PLLCON and PLLCFG
	mov R4,#85
	ldr R5,LIT_main+32
	str R4,[R5,#0]
	.dbline 66
; 
;   PCB_PINSEL0=0x00000000;                       // JTAG is via secondary port
	mov R4,#0
	ldr R5,LIT_main+36
	str R4,[R5,#0]
	.dbline 67
;   PCB_PINSEL1=0x55400000;
	ldr R4,LIT_main+40
	ldr R5,LIT_main+44
	str R4,[R5,#0]
	.dbline 69
;  
;   GPIO_IODIR=(0x00000000<<16)|                  // Make all inputs to start with
	mov R4,#0
	ldr R5,LIT_main+48
	str R4,[R5,#0]
	.dbline 72
; 	     0x00000000;
; 
;   GPIO_IODIR |= MICROBOLT_LED;                  // Setup MicroBolt LED as output
	ldr R4,LIT_main+48
	ldr R5,[R4,#0]
	orr R5,R5,#4194304
	str R5,[R4,#0]
	.dbline 74
; 
;   __ENABLE_INTERRUPT();                         // Enable all interrupts
	mrs R12,cpsr
	bic R12,R12,#0x80
	msr cpsr_c,R12
	
	b L3
L2:
	.dbline 83
; 
; /*
; |----------------------------------------------------
; |     Start of application
; |----------------------------------------------------
; */
; 
;   while(1)                                          // Do this forever
;     {
	.dbline 86
; 
; //----------------------------------------------------
;     FloatNum = 1 - 0.45;
	ldr R4,LIT_main+52
	ldr R6,[R4,#0]
	.dbline 88
;  
;     if (FloatNum == 0.55)
	ldr R4,LIT_main+56
	ldr R1,[R4,#0]
	mov R0,R6
	bl fpcmp
	bne L6
	.dbline 89
;       {
	.dbline 90
;       GPIO_IOSET = MICROBOLT_LED;                   // MicroBolt LED On
	mov R4,#4194304
	ldr R5,LIT_main+60
	str R4,[R5,#0]
	.dbline 91
;       }
L6:
	.dbline 94
	mov R7,#0
	b L12
L9:
	.dbline 94
L10:
	.dbline 94
	add R7,R7,#1
L12:
	.dbline 94
; //----------------------------------------------------
; 
;     for (Delay = 0; Delay < 3700000; Delay++);      // Delay for 1 Second
	ldr R4,LIT_main+64
	cmp R7,R4
	blo L9
	.dbline 97
; 
; //----------------------------------------------------
;     FloatNum = 1 - 0.3355;
	ldr R4,LIT_main+68
	ldr R6,[R4,#0]
	.dbline 99
; 
;     if (FloatNum == 0.6645)
	ldr R4,LIT_main+72
	ldr R1,[R4,#0]
	mov R0,R6
	bl fpcmp
	bne L14
	.dbline 100
;       {
	.dbline 101
;       GPIO_IOCLR = MICROBOLT_LED;                   // MicroBolt LED Off
	mov R4,#4194304
	ldr R5,LIT_main+76
	str R4,[R5,#0]
	.dbline 102
;       }
L14:
	.dbline 105
	mov R7,#0
	b L20
L17:
	.dbline 105
L18:
	.dbline 105
	add R7,R7,#1
L20:
	.dbline 105
; //----------------------------------------------------
; 
;     for (Delay = 0; Delay < 3700000; Delay++);      // Delay for 1 Second              
	ldr R4,LIT_main+64
	cmp R7,R4
	blo L17
	.dbline 108
; 
; //----------------------------------------------------
;     FloatNum = 1.55 * 8.456789;
	ldr R4,LIT_main+80
	ldr R6,[R4,#0]
	.dbline 110
; 
;     if (FloatNum == 13.1080229)
	ldr R4,LIT_main+84
	ldr R1,[R4,#0]
	mov R0,R6
	bl fpcmp
	bne L22
	.dbline 111
;       {
	.dbline 112
;       GPIO_IOSET = MICROBOLT_LED;                   // MicroBolt LED On
	mov R4,#4194304
	ldr R5,LIT_main+60
	str R4,[R5,#0]
	.dbline 113
;       }
L22:
	.dbline 116
	mov R7,#0
	b L28
L25:
	.dbline 116
L26:
	.dbline 116
	add R7,R7,#1
L28:
	.dbline 116
; //----------------------------------------------------
; 
;     for (Delay = 0; Delay < 3700000; Delay++);      // Delay for 1 Second
	ldr R4,LIT_main+64
	cmp R7,R4
	blo L25
	.dbline 119
; 
; //----------------------------------------------------
;     FloatNum = 2.5 / 0.425;
	ldr R4,LIT_main+88
	ldr R6,[R4,#0]
	.dbline 121
; 
;     if (FloatNum == 5.8823529)
	ldr R4,LIT_main+92
	ldr R1,[R4,#0]
	mov R0,R6
	bl fpcmp
	bne L30
	.dbline 122
;       {
	.dbline 123
;       GPIO_IOCLR = MICROBOLT_LED;                   // MicroBolt LED Off
	mov R4,#4194304
	ldr R5,LIT_main+76
	str R4,[R5,#0]
	.dbline 124
;       }
L30:
	.dbline 127
	mov R7,#0
	b L36
L33:
	.dbline 127
L34:
	.dbline 127
	add R7,R7,#1
L36:
	.dbline 127
	ldr R4,LIT_main+64
	cmp R7,R4
	blo L33
	.dbline 129
L3:
	.dbline 82
	b L2
X0:
	.dbline -2
L1:
	mov R15,R14
	.dbline 0 ; func end
LIT_main:
	DCD -534790144
	DCD -534790140
	DCD _pll_isr
	DCD -3808
	DCD -3552
	DCD -4080
	DCD -534790012
	DCD -534790016
	DCD -534790004
	DCD -536690688
	DCD 1430257664
	DCD -536690684
	DCD -536707064
	DCD L5
	DCD L8
	DCD -536707068
	DCD 3700000
	DCD L13
	DCD L16
	DCD -536707060
	DCD L21
	DCD L24
	DCD L29
	DCD L32
	.dbsym r FloatNum 6 D
	.dbsym r Delay 7 i
	.dbend
	EXPORT _pll_isr
	.dbfunc e pll_isr _pll_isr fV
	AREA	"C$$code", CODE, READONLY
	ALIGN 4
_pll_isr:
	sub R14,R14,#4
	stmfd R13!,{R0,R1,R11,R12,R14}
	mov R11,R13
	.dbline -1
	.dbline 144
; //----------------------------------------------------
; 
;     for (Delay = 0; Delay < 3700000; Delay++);      // Delay for 1 Second  
; 
;     }
;   }
; 
; /*
; |------------------------------------------------------------------------------------------
; |     Function        :   pll_isr
; |     Inputs          :   None
; |     Outputs         :   None
; |     Purpose         :   Once PLL has locked, connect it and use for system clock
; |     Author          :   Micromint, Inc.
; |------------------------------------------------------------------------------------------
; */
; 
; #pragma interrupt_handler pll_isr
; void pll_isr(void)
;   {
	.dbline 145
;   SCB_PLLCON |= 0x02;                           // Connect the PLL 
	ldr R0,LIT_pll_isr+0
	ldr R1,[R0,#0]
	orr R1,R1,#2
	str R1,[R0,#0]
	.dbline 146
;   SCB_PLLFEED = 0xAA;					   	  	          // Shadow register copy to enable changes
	mov R0,#170
	ldr R1,LIT_pll_isr+4
	str R0,[R1,#0]
	.dbline 147
;   SCB_PLLFEED = 0x55;                           // in PLLCON and PLLCFG
	mov R0,#85
	ldr R1,LIT_pll_isr+4
	str R0,[R1,#0]
	.dbline 148
;   VICIntEnClear = PLL_CLR;                      // Disable the PLL interrupt, not needed anymore
	mov R0,#4096
	ldr R1,LIT_pll_isr+8
	str R0,[R1,#0]
	.dbline 149
;   VICVectAddr = VIC_ACK;                        // Acknowledge Interrupt
	mov R0,#0
	ldr R1,LIT_pll_isr+12
	str R0,[R1,#0]
	.dbline -2
L37:
	ldmfd R13!,{R0,R1,R11,R12,PC}^
	.dbline 0 ; func end
LIT_pll_isr:
	DCD -534790016
	DCD -534790004
	DCD -4076
	DCD -4048
	.dbend
	AREA	"C$$code", CODE, READONLY
	ALIGN	4
L32:
	DCD 0x40bc3c3c   ; float 5.882353
	ALIGN	4
L29:
	DCD 0x40bc3c3c   ; float 5.882353
	ALIGN	4
L24:
	DCD 0x4151ba76   ; float 13.108023
	ALIGN	4
L21:
	DCD 0x4151ba76   ; float 13.108023
	ALIGN	4
L16:
	DCD 0x3f2a1cac   ; float 0.664500
	ALIGN	4
L13:
	DCD 0x3f2a1cac   ; float 0.664500
	ALIGN	4
L8:
	DCD 0x3f0ccccd   ; float 0.550000
	ALIGN	4
L5:
	DCD 0x3f0ccccd   ; float 0.550000
	END
